> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.meshapi.ai/llms.txt.
> For full documentation content, see https://developers.meshapi.ai/llms-full.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.meshapi.ai/_mcp/server.

# List Models

GET https://api.meshapi.ai/v1/models

List available models with per-user discounted pricing when applicable.

Only models registered in the `models` table with is_enabled=true are
returned. Accepts either a dashboard JWT or an API key.
Includes pricing per 1 000 tokens and a convenience ``is_free`` flag.
If the caller has an active discount, discounted prices are included.
Response is cached for 5 minutes; admin writes invalidate the cache immediately.

Reference: https://developers.meshapi.ai/api-reference/mesh-api/models/list-models-v-1-models-get

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: openapi
  version: 1.0.0
paths:
  /v1/models:
    get:
      operationId: list-models-v-1-models-get
      summary: List Models
      description: >-
        List available models with per-user discounted pricing when applicable.


        Only models registered in the `models` table with is_enabled=true are

        returned. Accepts either a dashboard JWT or an API key.

        Includes pricing per 1 000 tokens and a convenience ``is_free`` flag.

        If the caller has an active discount, discounted prices are included.

        Response is cached for 5 minutes; admin writes invalidate the cache
        immediately.
      tags:
        - subpackage_models
      parameters:
        - name: free
          in: query
          description: 'Filter: true = free models only, false = paid only, omit = all'
          required: false
          schema:
            type:
              - boolean
              - 'null'
        - name: type
          in: query
          description: 'Filter by model_type: text, embedding, image, audio, video'
          required: false
          schema:
            oneOf:
              - $ref: '#/components/schemas/V1ModelsGetParametersTypeSchema'
              - type: 'null'
        - name: provider
          in: query
          description: 'Filter by provider: amazon-bedrock, vertex, openai'
          required: false
          schema:
            type:
              - string
              - 'null'
        - name: Authorization
          in: header
          description: Bearer authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/ModelOut'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
servers:
  - url: https://api.meshapi.ai
components:
  schemas:
    V1ModelsGetParametersTypeSchema:
      type: string
      enum:
        - text
        - embedding
        - image
        - audio
        - video
      description: 'Filter by model_type: text, embedding, image, audio, video'
      title: V1ModelsGetParametersTypeSchema
    ModelPricing:
      type: object
      properties:
        prompt_usd_per_1k:
          type:
            - string
            - 'null'
        completion_usd_per_1k:
          type:
            - string
            - 'null'
        prompt_usd_per_1m:
          type:
            - string
            - 'null'
        completion_usd_per_1m:
          type:
            - string
            - 'null'
        image_usd_per_image:
          type:
            - string
            - 'null'
        audio_input_usd_per_1m:
          type:
            - string
            - 'null'
        audio_output_usd_per_1m:
          type:
            - string
            - 'null'
        cached_audio_input_usd_per_1m:
          type:
            - string
            - 'null'
        cached_text_input_usd_per_1m:
          type:
            - string
            - 'null'
        discount_pct:
          type:
            - string
            - 'null'
        prompt_usd_per_1k_discounted:
          type:
            - string
            - 'null'
        completion_usd_per_1k_discounted:
          type:
            - string
            - 'null'
        prompt_usd_per_1m_discounted:
          type:
            - string
            - 'null'
        completion_usd_per_1m_discounted:
          type:
            - string
            - 'null'
      required:
        - prompt_usd_per_1k
        - completion_usd_per_1k
      title: ModelPricing
    ModelOut:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
        provider:
          type:
            - string
            - 'null'
        context_length:
          type:
            - integer
            - 'null'
        is_free:
          type: boolean
        pricing:
          $ref: '#/components/schemas/ModelPricing'
        description:
          type:
            - string
            - 'null'
        supports_thinking:
          type: boolean
        supports_completions_api:
          type: boolean
        supports_responses_api:
          type: boolean
        supports_realtime:
          type: boolean
          default: false
        model_type:
          type: string
        input_modalities:
          type: array
          items:
            type: string
        output_modalities:
          type: array
          items:
            type: string
        is_composite:
          type: boolean
          default: false
        composite_models:
          type:
            - array
            - 'null'
          items:
            type: string
      required:
        - id
        - name
        - context_length
        - is_free
        - pricing
        - supports_thinking
        - supports_completions_api
        - supports_responses_api
        - model_type
        - input_modalities
        - output_modalities
      title: ModelOut
    ValidationErrorLocItems:
      oneOf:
        - type: string
        - type: integer
      title: ValidationErrorLocItems
    ValidationErrorCtx:
      type: object
      properties: {}
      title: ValidationErrorCtx
    ValidationError:
      type: object
      properties:
        loc:
          type: array
          items:
            $ref: '#/components/schemas/ValidationErrorLocItems'
        msg:
          type: string
        type:
          type: string
        input:
          description: Any type
        ctx:
          $ref: '#/components/schemas/ValidationErrorCtx'
      required:
        - loc
        - msg
        - type
      title: ValidationError
    HTTPValidationError:
      type: object
      properties:
        detail:
          type: array
          items:
            $ref: '#/components/schemas/ValidationError'
      title: HTTPValidationError
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

```

## SDK Code Examples

```python
import requests

url = "https://api.meshapi.ai/v1/models"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.meshapi.ai/v1/models';
const options = {
  method: 'GET',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.meshapi.ai/v1/models"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.meshapi.ai/v1/models")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.meshapi.ai/v1/models")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.meshapi.ai/v1/models', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.meshapi.ai/v1/models");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.meshapi.ai/v1/models")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```